using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using Microsoft.Win32;
using Utility.ModifyRegistry;


namespace MultiCOMM
{
    public partial class Form1 : Form
    { 
        About AboutForm = new About();
        ProductInfo ProductInfo = new ProductInfo();
        SerialPort SP1 = new SerialPort();
        SerialPort SP2 = new SerialPort();

        //// Instantiate the registry class
        //ModifyRegistry myRegistry = new ModifyRegistry();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            RemoveTabPages();
            AddComportToLists();
            InitBaudRate();
            InitParity();

            this.Text = ProductInfo.DevelopmentMode(ProductInfo.DevelopmentModeSwitch);
        }

        /// <summary>
        /// transfers the stored baudrates to the combo list boxes on all the tabs
        /// </summary>
        private void InitBaudRate()
        {
            Global.iBaud[0] = 110;
            Global.iBaud[1] = 300;
            Global.iBaud[2] = 600;
            Global.iBaud[3] = 1200;
            Global.iBaud[4] = 2400;
            Global.iBaud[5] = 4800;
            Global.iBaud[6] = 9600;
            Global.iBaud[7] = 14400;
            Global.iBaud[8] = 19200;
            Global.iBaud[9] = 28800;
            Global.iBaud[10] = 38400;
            Global.iBaud[11] = 57600;
            Global.iBaud[12] = 115200;

            for (Global.i = 0; Global.i < 13; Global.i++)
            {
                cboBaud1.Items.Add(Global.iBaud[Global.i]);
                cboBaud2.Items.Add(Global.iBaud[Global.i]);
                cboBaud3.Items.Add(Global.iBaud[Global.i]);
                cboBaud4.Items.Add(Global.iBaud[Global.i]);
                cboBaud5.Items.Add(Global.iBaud[Global.i]);
                cboBaud6.Items.Add(Global.iBaud[Global.i]);
                cboBaud7.Items.Add(Global.iBaud[Global.i]);
                cboBaud8.Items.Add(Global.iBaud[Global.i]);
                cboBaud9.Items.Add(Global.iBaud[Global.i]);
                cboBaud10.Items.Add(Global.iBaud[Global.i]);
                cboBaud11.Items.Add(Global.iBaud[Global.i]);
                cboBaud12.Items.Add(Global.iBaud[Global.i]);
                cboBaud13.Items.Add(Global.iBaud[Global.i]);
                cboBaud14.Items.Add(Global.iBaud[Global.i]);
                cboBaud15.Items.Add(Global.iBaud[Global.i]);
                cboBaud16.Items.Add(Global.iBaud[Global.i]);
                cboBaud17.Items.Add(Global.iBaud[Global.i]);
                cboBaud18.Items.Add(Global.iBaud[Global.i]);
                cboBaud19.Items.Add(Global.iBaud[Global.i]);
                cboBaud20.Items.Add(Global.iBaud[Global.i]);
                cboBaud21.Items.Add(Global.iBaud[Global.i]);
                cboBaud22.Items.Add(Global.iBaud[Global.i]);
                cboBaud23.Items.Add(Global.iBaud[Global.i]);
                cboBaud24.Items.Add(Global.iBaud[Global.i]);
            }
        }

        private void InitParity()
        {
            Global.sParity[0] = "None";
            Global.sParity[1] = "Even";
            Global.sParity[2] = "Odd";
            Global.sParity[3] = "Mark";
            Global.sParity[4] = "Space";

            for (Global.i = 0; Global.i < 5; Global.i++)
            {
                cboParity1.Items.Add(Global.sParity[Global.i]);
                cboParity2.Items.Add(Global.sParity[Global.i]);
                cboParity3.Items.Add(Global.sParity[Global.i]);
                cboParity4.Items.Add(Global.sParity[Global.i]);
                cboParity5.Items.Add(Global.sParity[Global.i]);
                cboParity6.Items.Add(Global.sParity[Global.i]);
                cboParity7.Items.Add(Global.sParity[Global.i]);
                cboParity8.Items.Add(Global.sParity[Global.i]);
                cboParity9.Items.Add(Global.sParity[Global.i]);
                cboParity10.Items.Add(Global.sParity[Global.i]);
                cboParity11.Items.Add(Global.sParity[Global.i]);
                cboParity12.Items.Add(Global.sParity[Global.i]);
                cboParity13.Items.Add(Global.sParity[Global.i]);
                cboParity14.Items.Add(Global.sParity[Global.i]);
                cboParity15.Items.Add(Global.sParity[Global.i]);
                cboParity16.Items.Add(Global.sParity[Global.i]);
                cboParity17.Items.Add(Global.sParity[Global.i]);
                cboParity18.Items.Add(Global.sParity[Global.i]);
                cboParity19.Items.Add(Global.sParity[Global.i]);
                cboParity20.Items.Add(Global.sParity[Global.i]);
                cboParity21.Items.Add(Global.sParity[Global.i]);
                cboParity22.Items.Add(Global.sParity[Global.i]);
                cboParity23.Items.Add(Global.sParity[Global.i]);
                cboParity24.Items.Add(Global.sParity[Global.i]);

            }
        }

        /// <summary>
        /// Removes all tabs except tab1
        /// </summary>
        private void RemoveTabPages()
        {
            // Removes all the tabs except tab 1
            tabControl1.TabPages.Remove(tabPage2);
            tabControl1.TabPages.Remove(tabPage3);
            tabControl1.TabPages.Remove(tabPage4);
            tabControl1.TabPages.Remove(tabPage5);
            tabControl1.TabPages.Remove(tabPage6);
            tabControl1.TabPages.Remove(tabPage7);
            tabControl1.TabPages.Remove(tabPage8);
            tabControl1.TabPages.Remove(tabPage9);
            tabControl1.TabPages.Remove(tabPage10);
            tabControl1.TabPages.Remove(tabPage11);
            tabControl1.TabPages.Remove(tabPage12);
            tabControl1.TabPages.Remove(tabPage13);
            tabControl1.TabPages.Remove(tabPage14);
            tabControl1.TabPages.Remove(tabPage15);
            tabControl1.TabPages.Remove(tabPage16);
            tabControl1.TabPages.Remove(tabPage17);
            tabControl1.TabPages.Remove(tabPage18);
            tabControl1.TabPages.Remove(tabPage19);
            tabControl1.TabPages.Remove(tabPage20);
            tabControl1.TabPages.Remove(tabPage21);
            tabControl1.TabPages.Remove(tabPage22);
            tabControl1.TabPages.Remove(tabPage23);
            tabControl1.TabPages.Remove(tabPage24);
        }

        /// <summary>
        /// Adds comports to each comport listbox
        /// </summary>
        private void AddComportToLists()
        {
            int i = 1;

            //Adds the comport name to all the listboxes
            foreach (string portName in SerialPort.GetPortNames())
            {
                try
                {
                    SP1.PortName = portName;
                    SP1.Open();
                }
                catch (Exception)
                {
                    // Do nothing
                }


                if (SP1.IsOpen == true)
                {
                    lstCommList1.Items.Add(portName);
                    lstCommList2.Items.Add(portName);
                    lstCommList3.Items.Add(portName);
                    lstCommList4.Items.Add(portName);
                    lstCommList5.Items.Add(portName);
                    lstCommList6.Items.Add(portName);
                    lstCommList7.Items.Add(portName);
                    lstCommList8.Items.Add(portName);
                    lstCommList9.Items.Add(portName);
                    lstCommList10.Items.Add(portName);
                    lstCommList11.Items.Add(portName);
                    lstCommList12.Items.Add(portName);
                    lstCommList13.Items.Add(portName);
                    lstCommList14.Items.Add(portName);
                    lstCommList15.Items.Add(portName);
                    lstCommList16.Items.Add(portName);
                    lstCommList17.Items.Add(portName);
                    lstCommList18.Items.Add(portName);
                    lstCommList19.Items.Add(portName);
                    lstCommList20.Items.Add(portName);
                    lstCommList21.Items.Add(portName);
                    lstCommList22.Items.Add(portName);
                    lstCommList23.Items.Add(portName);
                    lstCommList24.Items.Add(portName);

                    if (i >= 2)
                    {
                        switch (i)
                        {
                            case 2:
                                tabControl1.TabPages.Add(tabPage2);
                                break;
                            case 3:
                                tabControl1.TabPages.Add(tabPage3);
                                break;
                            case 4:
                                tabControl1.TabPages.Add(tabPage4);
                                break;
                            case 5:
                                tabControl1.TabPages.Add(tabPage5);
                                break;
                            case 6:
                                tabControl1.TabPages.Add(tabPage6);
                                break;
                            case 7:
                                tabControl1.TabPages.Add(tabPage7);
                                break;
                            case 8:
                                tabControl1.TabPages.Add(tabPage8);
                                break;
                            case 9:
                                tabControl1.TabPages.Add(tabPage9);
                                break;
                            case 10:
                                tabControl1.TabPages.Add(tabPage10);
                                break;
                            case 11:
                                tabControl1.TabPages.Add(tabPage11);
                                break;
                            case 12:
                                tabControl1.TabPages.Add(tabPage12);
                                break;
                            case 13:
                                tabControl1.TabPages.Add(tabPage13);
                                break;
                            case 14:
                                tabControl1.TabPages.Add(tabPage14);
                                break;
                            case 15:
                                tabControl1.TabPages.Add(tabPage15);
                                break;
                            case 16:
                                tabControl1.TabPages.Add(tabPage16);
                                break;
                            case 17:
                                tabControl1.TabPages.Add(tabPage17);
                                break;
                            case 18:
                                tabControl1.TabPages.Add(tabPage18);
                                break;
                            case 19:
                                tabControl1.TabPages.Add(tabPage19);
                                break;
                            case 20:
                                tabControl1.TabPages.Add(tabPage20);
                                break;
                            case 21:
                                tabControl1.TabPages.Add(tabPage21);
                                break;
                            case 22:
                                tabControl1.TabPages.Add(tabPage22);
                                break;
                            case 23:
                                tabControl1.TabPages.Add(tabPage23);
                                break;
                            case 24:
                                tabControl1.TabPages.Add(tabPage24);
                                break;
                        }   
                    }

                    i++;
                    SP1.Close();
                }
            }
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
        
        private void btnCommClose1_Click(object sender, EventArgs e)
        {
            try
            {
                SP1.Close();
            }
            catch (Exception)
            {
                lblComportNumber1.Text = "Error";
                lblComportNumber1.BackColor = Color.Red;
            }
            
            if (SP1.IsOpen == false)
            {
                lblComportNumber1.Text = "";
                lblComportNumber1.BackColor = Color.Silver;
            }
        }

        private void btnCommOpen1_Click(object sender, EventArgs e)
        {
            //int x = 0;

            //try
            //{
            //    x = lstCommList1.SelectedIndex;
            //    if (x >= 0)
            //    {
            //        Global.ComPortName[0] = lstCommList1.SelectedItem.ToString();
            //        SP1.PortName = Global.ComPortName[0];
            //        SP1.Open();
            //    }
            //    else
            //        MessageBox.Show("Commport not selected", "Serial Error");
            //}
            //catch (Exception)
            //{
            //    MessageBox.Show("Comport already open", "Serial Error");
            //}
           
            //if (SP1.IsOpen == true)
            //{
            //    lblComportNumber1.Text = Global.ComPortName[0];
            //    lblComportNumber1.BackColor = Color.Green;
            //}
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutForm.ShowDialog();
        }

        private void cboBaud1_SelectedIndexChanged(object sender, EventArgs e)
        {
            SP1.BaudRate = int.Parse(cboBaud1.Text);
        }

        private void btnCommOpen2_Click(object sender, EventArgs e)
        {
            try
            {
                Global.ComPortName[1] = lstCommList2.SelectedItem.ToString();
                SP2.PortName = Global.ComPortName[1];
                SP2.Open();
            }
            catch (Exception)
            {
                MessageBox.Show("Comport already open", "Serial Error");
                //lblComportNumber2.Text = "Error";
                //lblComportNumber2.BackColor = Color.Red;
            }

            if (SP2.IsOpen == true)
            {
                lblComportNumber2.Text = Global.ComPortName[1];
                lblComportNumber2.BackColor = Color.Green;
            }
        }

        private void btnCommClose2_Click(object sender, EventArgs e)
        {
            try
            {
                SP2.Close();
            }
            catch (Exception)
            {
                lblComportNumber2.Text = "Error";
                lblComportNumber2.BackColor = Color.Red;
            }

            if (SP2.IsOpen == false)
            {
                lblComportNumber2.Text = "";
                lblComportNumber2.BackColor = Color.Silver;
            }
        }

        private void cboParity1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cboParity1.Text == "None")
                SP1.Parity = Parity.None;
            else if (cboParity1.Text == "Even")
                SP1.Parity = Parity.Even;
            else if (cboParity1.Text == "Odd")
                SP1.Parity = Parity.Odd;
            else if (cboParity1.Text == "Mark")
                SP1.Parity = Parity.Mark;
            else if (cboParity1.Text == "Space")
                SP1.Parity = Parity.Space;

        }

        static void PrintKeys(RegistryKey rkey)
        {

            // Retrieve all the subkeys for the specified key.
            String[] names = rkey.GetSubKeyNames();

            int icount = 0;

            MessageBox.Show("Subkeys of " + rkey.Name);

            // Print the contents of the array to the console. 
            foreach (String s in names)
            {
                MessageBox.Show(s);

                // The following code puts a limit on the number 
                // of keys displayed.  Comment it out to print the 
                // complete list.
                icount++;
                if (icount >= 10)
                    break;
            }
        }
    }
}