﻿/////////////////////////////////////////////////////////////////////////////
// Global.cs
// 
// Program Tytle:  BlueJay
// Author:  Simon Nixon
// Copyright: 2011 ©
// Description: This file is for application wide methods and properties
//
// IDE: Microsoft Visual Studio 2010 Professional
//
/////////////////////////////////////////////////////////////////////////////
using System;
using System.Reflection;

namespace MultiCOMM
{
   /// <summary>
   /// Description of GlobalData.
   /// </summary>
   public class ProductInfo
   {
      //==============================   
      // private variables
      //==============================
      private static string _VersionInfo;
      private static bool _DevMode = false;
      private static string _DevelopmentWarning = "";
      private static string _ProductTitle = "";
      private static string _Copyright = "";
      
      
      //==============================
      // public properties
      //==============================

      public string ProductTitle
      {
          get
          {
              return _ProductTitle;
          }
          set
          {
              _ProductTitle = value;
          }
      }

      public string Copyright
      {
          get
          {
              return _Copyright;
          }
          set
          {
              _Copyright = value;
          }
      }

      public string VersionInfo
      {
         get
         {
            return _VersionInfo;
         }
         set
         {
            _VersionInfo = value;
         }
      }
      
      public bool DevelopmentModeSwitch
      {
         get
         {
            return _DevMode;
         }
         set
         {
            _DevMode = value;
         }
      }
      
      public string DevelopmentWarning
      {
         get
         {
            return _DevelopmentWarning;
         }
         set
         {
            _DevelopmentWarning = value;
         }
      }

      //==============================
      // public methods
      //==============================
      public string GetVersion()
      {
      	if(DevelopmentModeSwitch == true)
      	{
            VersionInfo = Assembly.GetExecutingAssembly().GetName().Version.Major.ToString()
                    + "." + Assembly.GetExecutingAssembly().GetName().Version.Minor.ToString()
                     + "." + Assembly.GetExecutingAssembly().GetName().Version.Build.ToString();
      	}
      	else
      	{
      		VersionInfo = Assembly.GetExecutingAssembly().GetName().Version.Major.ToString()
                  	+"."+ Assembly.GetExecutingAssembly().GetName().Version.Minor.ToString();
      	}
         	
        return VersionInfo;
      }

      public string DevelopmentMode(bool DevelopmentFlag)
      {
          if (DevelopmentFlag == true)
          {
              return ProductTitle + DevelopmentWarning;
          }
          else
          {
              return ProductTitle;
          }
      }
   }
}
